`timescale 1ns/1ns
//
module tb_i2s();
    parameter PSCALE=3, DW=16;
    //
    reg  clk;
    reg  nd_i;
    reg  reset;

    wire wclk, bclk, dac0;
    wire[DW-1:0] x_i = 'h199;
    i2s #(.PSCALE(PSCALE),.DW(DW))
    dut(
        .clk        (clk        ),  // i DSP clock 32MHz
        .nd_i       (nd_i       ),  // i Convertion start
        .x_i        ({x_i, x_i} ),  // i[2*DW-1:0] DAC
        .wck_o      (wclk       ),  // o Load buffer/irq
        .bck_o      (bclk       ),  // o bitclock
        .y_o        (dac0       )   // dac sdata
    );
    //---------------------------
    initial // Reset
    begin
        fork
            reset   = 1;
            nd_i    = 0;
            clk     = 0;
        join
            repeat (5) @(posedge clk);
            #1 reset = 0;
            repeat (3) @(negedge nd_i);
            #200 $stop;
    end
    //----------------------------
    initial
    begin
        @(posedge clk);
        wait(!reset);
        @(posedge clk);
        forever
        begin
            @(posedge clk);
            #1 nd_i = 1;
            @(posedge clk);
            #1 nd_i = 0;
            repeat ((PSCALE*2*DW-2)+0) @(posedge clk);
        end // forever
    end
    //----------------------------
    initial
        forever #5 clk = ~clk;
    //----------------------------
endmodule
//
